package org.jeecg.modules.stm.base.domain.service;

import org.jeecg.common.system.vo.SelectTreeModel;
import org.jeecg.modules.stm.base.domain.entity.StDomain;
import org.jeecg.modules.stm.base.domain.vo.StDomainVo;
import com.baomidou.mybatisplus.extension.service.IService;
import org.jeecg.common.exception.JeecgBootException;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;

import java.util.List;
import java.util.Map;

/**
 * @Description: st_domain
 * @Author: yzh
 * @Date:   2023-03-09
 * @Version: V1.0
 */
public interface IStDomainService extends IService<StDomain> {

	/**根节点父ID的值*/
	public static final String ROOT_PID_VALUE = "0";
	
	/**树节点有子节点状态值*/
	public static final String HASCHILD = "1";
	
	/**树节点无子节点状态值*/
	public static final String NOCHILD = "0";

	/**
	 * 新增节点
	 *
	 * @param stDomain
	 */
	void addStDomain(StDomain stDomain);
	
	/**
   * 修改节点
   *
   * @param stDomain
   * @throws JeecgBootException
   */
	void updateStDomain(StDomain stDomain) throws JeecgBootException;
	
	/**
	 * 删除节点
	 *
	 * @param id
   * @throws JeecgBootException
	 */
	void deleteStDomain(String id) throws JeecgBootException;

	  /**
	   * 查询所有数据，无分页
	   *
	   * @param queryWrapper
	   * @return List<StDomain>
	   */
    List<StDomain> queryTreeListNoPage(QueryWrapper<StDomain> queryWrapper);

	/**
	 * 【vue3专用】根据父级编码加载分类字典的数据
	 *
	 * @param parentCode
	 * @return
	 */
	List<SelectTreeModel> queryListByCode(String parentCode);

	/**
	 * 【vue3专用】根据pid查询子节点集合
	 *
	 * @param pid
	 * @return
	 */
	List<SelectTreeModel> queryListByPid(String pid);

    StDomainVo queryEntityByCode(String domainCode);

    void changeParent(StDomain stDomain);

	Map<String,String> getAllParentCode(List<String> codes);

	String getDomainCode(StDomain entity);
}
